#include "globals.h"
#include "hal_ioexp.h"
#include "hal_buzzer.h"
#include "hal_button.h"
#include "hal_adc.h"
#include "app_timer.h"
#include "nrf_drv_clock.h"
#include "hal_timer.h"
#include "nrf_gpio.h"
#include "nrf_drv_rtc.h"

/***********************************************************************************
* CONSTANTS AND DEFINES
*/






/***********************************************************************************
* ENUMS
*/



/***********************************************************************************
* MACROS
*/
const nrf_drv_rtc_t rtc = NRF_DRV_RTC_INSTANCE(0); /**< Declaring an instance of nrf_drv_rtc for RTC0. */


/***********************************************************************************
* TYPEDEFS
*/



/***********************************************************************************
* GLOBALS
*/





/***********************************************************************************
* LOCALS
*/

uint8_t Timer_ID;




/***********************************************************************************
* FUNCTIONS
*/

/** @brief Function initialization and configuration of RTC driver instance.
 */
static void rtc_config(void)
{
    uint32_t err_code;

    //Initialize RTC instance
    nrf_drv_rtc_config_t config = NRF_DRV_RTC_DEFAULT_CONFIG;
    config.prescaler = 4095;
    err_code = nrf_drv_rtc_init(&rtc, &config, rtc_handler);
    APP_ERROR_CHECK(err_code);

    //Enable tick event & interrupt
    nrf_drv_rtc_tick_enable(&rtc,true);

    //Set compare channel to trigger interrupt after COMPARE_COUNTERTIME seconds
    err_code = nrf_drv_rtc_cc_set(&rtc, 0, 1, true);
    APP_ERROR_CHECK(err_code);

    //Power on RTC instance
    nrf_drv_rtc_enable(&rtc);
}

/*
* Hal_Timer_Init
*/
void Hal_Timer_Init(void)
{
ret_code_t err_code = nrf_drv_clock_init();

  APP_ERROR_CHECK(err_code);
  nrf_drv_clock_lfclk_request(NULL);
//  nrfx_clock_lfclk_start();
//  while (!nrf_drv_clock_lfclk_is_running());

  rtc_config();
}

static void rtc_handler(nrf_drv_rtc_int_type_t int_type)
{

  if (int_type == NRF_DRV_RTC_INT_COMPARE0)
  {
    EventsApp.RTC |= Event_RTC_Timeout;
  }
  else if (int_type == NRF_DRV_RTC_INT_TICK)
  {

  }
}

/*
* Hal_Timer_Blink_RGB
*/
void Hal_Timer_Blink_RGB(void)
{
static bool toogle = true;

  EventsApp.RTC &= ~Event_RTC_Timeout;

  if (toogle)
  {
    encenLedRGB(RGB_WARNING, VERMELL, false, false);
  }
  else
  {
    bitClearAll();
  }

  toogle = !toogle;
}